/*
* Copyright (C) 2019 ~ 2020 UnionTech Software Technology Co.,Ltd
*
* Author:     zhanghao<zhanghao@uniontech.com>
* Maintainer: zhanghao<zhanghao@uniontech.com>
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* any later version.
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QPainter>
#include <QtSvg/QSvgRenderer>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::on_pushButton_clicked()
{
    ui->textEdit->setHtml(QCoreApplication::translate("Widget", "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
                                                              "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
                                                              "p, li { white-space: pre-wrap; }\n"
                                                              "</style></head><body style=\" font-family:'Noto Sans CJK SC'; font-size:10.5pt; font-weight:400; font-style:normal;\">\n"
                                                              "<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; "
            "-qt-block-indent:0; text-indent:0px;\">3d055b<span style=\" font-size:72pt;\">fd4aae</span>8e219a5d233</p></body></html>", nullptr));

}

void MainWindow::on_comboBox_currentTextChanged(const QString &arg1)
{
    QFont font(ui->fontComboBox->currentText());
    font.setPixelSize(arg1.toUInt());
    ui->textEdit->setCurrentFont(font);
}

void MainWindow::on_fontComboBox_currentTextChanged(const QString &arg1)
{
    QFont font(arg1);
    font.setPixelSize(ui->comboBox->currentText().toUInt());
    ui->textEdit->setCurrentFont(font);
}


void MainWindow::on_pushButton_2_clicked()
{
    const QString svgFileLocation = ":/Resources/smiley.svg";
    QTextImageFormat format;
    format.setName(svgFileLocation);
    QSvgRenderer renderer(svgFileLocation);
    const auto height = 19;
    QImage image(height, height, QImage::Format_ARGB32);
    image.fill(Qt::transparent);
    QPainter painter(&image);
    renderer.render(&painter);format.setVerticalAlignment(QTextCharFormat::AlignBottom);

    ui->textEdit->document()->addResource(QTextDocument::ImageResource, svgFileLocation, image);

    QTextCursor newCursor(ui->textEdit->document());
    newCursor.insertText("hello ");
    newCursor.insertImage(format);
}

